/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#include "aboutwindow.h"
#include "aboutwindow_signals.h"
#include "fmdialog.h"

/* XPM */
static char * pgsFmLogoXpm[] = 
{
	"100 141 11 1",
	" 	c None",
	".	c #FFFFFF",
	"+	c #E3E3E3",
	"@	c #727272",
	"#	c #000000",
	"$	c #1D1D1D",
	"%	c #AAAAAA",
	"&	c #8E8E8E",
	"*	c #555555",
	"=	c #393939",
	"-	c #C7C7C7",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                           +%%***********@%%%                                                       ",
	"                       -&*######################=*%+                                                ",
	"                    +&$#############################$*%                                             ",
	"                  +@####################################*%                                          ",
	"                 %$########################################*-                                       ",
	"                *############################################$&+                                    ",
	"               *################################################@-                                  ",
	"              *###################################################=-                                ",
	"             &######################################################=-                              ",
	"            +#########################################################=-                            ",
	"            @###########################################################@+                          ",
	"           +#############################################################$&                         ",
	"           @###############################################################=+                       ",
	"           $################################################################$%                      ",
	"          +###################################################################*                     ",
	"          %####################################################################*+                   ",
	"          &#####################################################################$+                  ",
	"          *################################$*@%%          %%@*###################$+                 ",
	"          *#############################=&+                    -&=################$+                ",
	"          *###########################=-                          +@$##############*                ",
	"          *#########################$-                               &$#############&               ",
	"          *########################*+                                  &#############+              ",
	"          *#######################*                                     +*###########=              ",
	"          *######################*                                        &###########-             ",
	"          &#####################$+                                         %##########=             ",
	"          %#####################-                                           %##########+            ",
	"          +####################@                                             %#########@            ",
	"           ####################+                                              *########$            ",
	"           =##################@                                               +$########-           ",
	"           @##################+                                                @########@           ",
	"           %#################*                                                 +########=           ",
	"            #################%                                                  =########           ",
	"            =################                                                   *########%          ",
	"            &###############*                                                   %########&          ",
	"            +###############@                                                   %########*          ",
	"             $##############%                                                   %########*          ",
	"             @##############+                                                   %#########          ",
	"             -##############                                                    %#########          ",
	"              $############$                                                    *#########          ",
	"              @############*                                                    *#########          ",
	"              %############*                                                    $#########          ",
	"               ############*                                                   +##########          ",
	"               *###########*                                                   &##########          ",
	"               %###########*                                                   *##########          ",
	"               +###########*                                                   ###########          ",
	"                =##########*                                                  &###########          ",
	"                @##########*                                                  =###########          ",
	"                -##########*                                                 -############          ",
	"                 ##########*                                                 =###########=          ",
	"                 *#########*                                                -############*          ",
	"                 %#########*                                                =############*          ",
	"                 +#########$                                                %$###########*          ",
	"                  $#########                                                 +=##########%          ",
	"                  *#########                                                   &#########%          ",
	"                  %#########%                                                   +=#######%          ",
	"                  +#########%                                                     @######%          ",
	"                   $########@                                                      -$####           ",
	"                   *########*                      %@*#####=*%-                      @###           ",
	"                   %########$                   +@#############$@-                    %$#           ",
	"                   +#########                  &##################=&                   +*           ",
	"                    $########-                *#####################$&                              ",
	"                    *########%               *########################=-                            ",
	"                    %########*              &###########################*+                          ",
	"                    +########=             +#############################$%                         ",
	"                     #########             @###############################@                        ",
	"                     *########%            $##########$&+   %&=#############*+                      ",
	"                     &########@           -##########*         +@############$+                     ",
	"                     %########=           @#########*            +*###########$+                    ",
	"                      #########           *########$               %$##########$+                   ",
	"                      =########%          $########&                +$##########$+                  ",
	"                      *########@          #########                  +$##########$+                 ",
	"                      %########$          ########=                   +$##########$+                ",
	"                      -#########+         ########@                    +$##########=                ",
	"                       #########&         ########%                     +$##########*               ",
	"                       =########*         ########%                      -###########               ",
	"                       @#########         ########%                       &#########*               ",
	"                       %#########%        $#######%                        *########@               ",
	"                       -#########@        *#######%                        +$#######%               ",
	"                        #########$        *#######%                         &#######+               ",
	"                        =#########+       %#######%                          =######                ",
	"                        *#########&       +#######*                          -#####*                ",
	"                        %#########*        #######*                           @####@                ",
	"                        -##########        *#######                           +####%                ",
	"                         ##########%       %#######-                           @###+                ",
	"                         $#########*       +#######&                           +###                 ",
	"                         *#########$        =######*                            @#*                 ",
	"                         @##########-       &#######                            +#@                 ",
	"                         %##########&       +#######%                            @%                 ",
	"                         -##########=        =######=                            -+                 ",
	"                          ###########+       &#######-                                              ",
	"                          $##########%        #######@                                              ",
	"                          *##########*        *#######+                                             ",
	"                          @###########        -#######@                                             ",
	"                          %###########%        $#######+                                            ",
	"                          -###########@        &#######*                                            ",
	"                           ###########$        +########%                                           ",
	"                           ############-        @#######$                                           ",
	"                           *###########&        +########@                                          ",
	"                           *###########=         =########-                                         ",
	"                           %############+        -########$                                         ",
	"                           %############&         =########@                                        ",
	"                           -############*         %#########-                                       ",
	"                            #############          $########$                                       ",
	"                            #############%         &#########@                                      ",
	"                            *############*          $#########%                                     ",
	"                            *############$          &#########$+                                    ",
	"                            @#############-          $#########*                                    ",
	"                            %#############@          &##########&                                   ",
	"                            %#############$           $##########-                                  ",
	"                            +##############-          &##########$+                                 ",
	"                             ##############@           $##########*                                 ",
	"                             ##############$           -###########&                                ",
	"                             =##############+           =###########-                               ",
	"                             *##############&           -###########$+                              ",
	"                             *##############=            =###########*                              ",
	"                             &###############+           +############@                             ",
	"                             %###############&            @############%                            ",
	"                             %###############=            +#############+                           ",
	"                             %################+            &############$+                          ",
	"                              ################&             $############*                          ",
	"                              ################=             -#############*                         ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    ",
	"                                                                                                    "
};

void aboutWindow_destroy(struct AboutWindow **aboutWindow)
{
	if(*aboutWindow)
	{
		gtk_widget_destroy((*aboutWindow)->pLabelCenter);
		gtk_widget_destroy((*aboutWindow)->pHSeperator1);
		gtk_widget_destroy((*aboutWindow)->pLabelTop);
		gtk_widget_destroy((*aboutWindow)->pVBoxText);
		gtk_widget_destroy((*aboutWindow)->pPixmapLogo);
		gtk_widget_destroy((*aboutWindow)->pEventBoxLogo);
		gtk_widget_destroy((*aboutWindow)->pFrameLogo);
		gtk_widget_destroy((*aboutWindow)->pHBoxMain);
		gtk_widget_destroy((*aboutWindow)->pDialog);

		g_free(*aboutWindow);

		*aboutWindow = NULL;
	}
}

struct AboutWindow* aboutWindow_new()
{
	static struct AboutWindow	*about_window = NULL;
	GtkStyle					*logo_style = NULL;
	GdkPixmap 					*pixmap_logo = NULL;
	GdkBitmap 					*mask_logo = NULL;
  
	if(about_window)
	{
		gdk_window_raise(about_window->pDialog->window);
	}
	else
	{
		about_window = g_new(struct AboutWindow, 1);
		if(about_window)
		{
			about_window->pDialog = NULL;
			about_window->pEventBoxLogo = NULL;
			about_window->pFrameLogo = NULL;
			about_window->pHBoxMain = NULL;
			about_window->pHSeperator1 = NULL;
			about_window->pLabelCenter = NULL;
			about_window->pLabelTop = NULL;
			about_window->pPixmapLogo = NULL;
			about_window->pVBoxText = NULL;

			about_window->pDialog = fmDialog_new("About", "fm_about", GTK_WIN_POS_NONE, FALSE, TRUE, FALSE,
				 "Close", aboutWindow_buttonClose, &about_window, TRUE, TRUE,
				 NULL);

			/* The main hbox */
			about_window->pHBoxMain = gtk_hbox_new(FALSE, 6);
			gtk_container_set_border_width(GTK_CONTAINER (about_window->pHBoxMain), 6);
			gtk_box_pack_start(GTK_BOX(GTK_DIALOG(about_window->pDialog)->vbox), about_window->pHBoxMain, TRUE, TRUE, 0);

			/* The logo pixmap and its frame */
			about_window->pFrameLogo = gtk_frame_new(NULL);
			gtk_box_pack_start(GTK_BOX(about_window->pHBoxMain), about_window->pFrameLogo, FALSE, FALSE, 0);

			about_window->pEventBoxLogo = gtk_event_box_new();
			gtk_container_add(GTK_CONTAINER(about_window->pFrameLogo), GTK_WIDGET(about_window->pEventBoxLogo));

			gtk_widget_ensure_style(GTK_WIDGET(about_window->pEventBoxLogo));
			logo_style = gtk_style_copy(GTK_WIDGET(about_window->pEventBoxLogo)->style);
            logo_style->bg[GTK_STATE_NORMAL].red = 0xffff;
            logo_style->bg[GTK_STATE_NORMAL].green = 0xffff;
            logo_style->bg[GTK_STATE_NORMAL].blue = 0xffff;
			gtk_widget_set_style(GTK_WIDGET(about_window->pEventBoxLogo), logo_style);
			gtk_style_unref(logo_style);
			
			pixmap_logo = gdk_pixmap_colormap_create_from_xpm_d(NULL, gdk_colormap_get_system(), &(mask_logo), NULL, pgsFmLogoXpm);

            about_window->pPixmapLogo = gtk_pixmap_new(pixmap_logo, mask_logo);
			gtk_container_add(GTK_CONTAINER(about_window->pEventBoxLogo), GTK_WIDGET(about_window->pPixmapLogo));
			
			/* The text vbox */
			about_window->pVBoxText = gtk_vbox_new(FALSE, 6);
			gtk_container_set_border_width(GTK_CONTAINER (about_window->pVBoxText), 6);
			gtk_box_pack_start(GTK_BOX(about_window->pHBoxMain), about_window->pVBoxText, TRUE, TRUE, 0);

			/* The about text */
			about_window->pLabelTop = gtk_label_new("");
			gtk_label_set_justify(GTK_LABEL(about_window->pLabelTop), GTK_JUSTIFY_CENTER);
			gtk_label_set_text(GTK_LABEL(about_window->pLabelTop), "Fm v0.2\nProgrammed by G. Bevin in 1999.\ngbevin@thunderstorms.org\nhttp://thunderstorms.org/fm");
			gtk_box_pack_start(GTK_BOX(about_window->pVBoxText), about_window->pLabelTop, FALSE, FALSE, 0);
			
			about_window->pHSeperator1 = gtk_hseparator_new();
			gtk_box_pack_start(GTK_BOX(about_window->pVBoxText), about_window->pHSeperator1, FALSE, FALSE, 0);

			about_window->pLabelCenter = gtk_label_new("");
			gtk_label_set_justify(GTK_LABEL(about_window->pLabelCenter), GTK_JUSTIFY_CENTER);
			gtk_label_set_text(GTK_LABEL(about_window->pLabelCenter), "This is an unstable release with probably many bugs still present.\n\nUse it at your own risk, I will not be held responsible\nfor any damage caused to your system!\n\nPlease notify me about any suggestion you have or\nbugs you found at the above email address.");
			gtk_box_pack_start(GTK_BOX(about_window->pVBoxText), about_window->pLabelCenter, TRUE, TRUE, 0);

			gtk_widget_show(about_window->pLabelCenter);
			gtk_widget_show(about_window->pHSeperator1);
			gtk_widget_show(about_window->pLabelTop);
			gtk_widget_show(about_window->pVBoxText);
			gtk_widget_show(about_window->pPixmapLogo);
			gtk_widget_show(about_window->pEventBoxLogo);
			gtk_widget_show(about_window->pFrameLogo);
			gtk_widget_show(about_window->pHBoxMain);
			gtk_widget_show(about_window->pDialog);
		}
	}

	return about_window;
}

