/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#include <stdio.h>
#include <string.h>

#include <glib.h>
#include <gtk/gtk.h>

#include "ctreecolumn.h"
#include "preferences.h"

void ctreeColumnAdd(struct Preferences *preferences, int type, int alignment)
{
	struct CtreeColumn	*ctree_column = g_new(struct CtreeColumn, 1);

    ctree_column->type = type;
    ctree_column->alignment = alignment;

	preferences->pCtreeColumns = g_list_append(preferences->pCtreeColumns, ctree_column);
}
		
struct CtreeColumn* ctreeColumnFind(struct Preferences *preferences, int type)
{
	GList	*ctree_column = preferences->pCtreeColumns;

	while(ctree_column)
	{
		if(((struct CtreeColumn*)ctree_column->data)->type == type)
		{
			return (struct CtreeColumn*)ctree_column->data;
		}
		ctree_column = ctree_column->next;
	}

	return NULL;
}
		
void ctreeColumnRemove(struct Preferences *preferences, int type)
{
	GList	*ctree_column = preferences->pCtreeColumns;

	while(ctree_column)
	{
		if(((struct CtreeColumn*)ctree_column->data)->type == type)
		{
			preferences->pCtreeColumns = g_list_remove_link(preferences->pCtreeColumns, ctree_column);
			g_free(ctree_column->data);
			g_list_free_1(ctree_column);
			return;
		}
		ctree_column = ctree_column->next;
	}
}
		
void ctreeColumnsFree(struct Preferences *preferences)
{
	GList	*ctree_column = NULL;

	while(g_list_length(preferences->pCtreeColumns))
	{
        ctree_column = preferences->pCtreeColumns;
		preferences->pCtreeColumns = g_list_remove_link(preferences->pCtreeColumns, ctree_column);
		g_free(ctree_column->data);
		g_list_free_1(ctree_column);
	}
}


