/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#ifndef __CTREE_COLUMN_H__
#define __CTREE_COLUMN_H__

#include <gdk/gdktypes.h>
#include <glib.h>

#include "preferences.h"

typedef enum
{
	COLUMN_BOOKMARK,
	COLUMN_FILENAME,
	COLUMN_SIZE,
	COLUMN_USER,
	COLUMN_GROUP,
	COLUMN_PERMISSIONS,
	COLUMN_MODIFICATION_TIME,
	COLUMN_CHANGE_TIME
} ColumnType;

struct CtreeColumn
{
	guint	type;
	guint	alignment;
};

void				ctreeColumnAdd(struct Preferences*, int, int);
struct CtreeColumn*	ctreeColumnFind(struct Preferences*, int);
void				ctreeColumnRemove(struct Preferences*, int);
void				ctreeColumnsFree(struct Preferences*);

#endif /* __CTREE_COLUMN_H__ */

