/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#ifndef __FILE_TYPE_H__
#define __FILE_TYPE_H__

#include "rowstyle.h"

typedef enum
{
	REGULAR_FILE,
	DIRECTORY_FILLED,
	DIRECTORY_EMPTY,
	DIRECTORY_INACCESSIBLE,
	CHARACTER_DEVICE,
	BLOCK_DEVICE,
	BROKEN_LINK,
	SOCKET,
	FIFO,
	UNKNOWN
} BasicFileType;

struct FileType
{
	gboolean		deletable;
	BasicFileType	basicType;
	struct RowStyle	*pRowStyle;
};

gint				fileTypeCompare(gconstpointer, gconstpointer);
struct FileType*	fileTypeGet(GList*, GNode*);
struct FileType*	fileTypeNew(GList**, GHashTable*, gboolean, BasicFileType, gchar*);
void				fileTypeRemove(GList**, struct FileType*);
void				fileTypesRemoveAll(GList**);

#endif /* __FILE_TYPE_H__ */

