/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#ifndef __FILE_UTILS_H__
#define __FILE_UTILS_H__

#include <time.h>

gchar*				compressPath(gchar*);
gchar*				getFormattedTime(time_t);
GNode*				getLinkSource(GNode*);
GNode*				getLinkTarget(GNode*);
gchar*				getAccessTime(GNode*);
gchar*				getChangeTime(GNode*);
gchar*				getGroupName(GNode*);
gchar*				getModificationTime(GNode*);
gchar*				getPermissions(GNode*);
gchar*				getSize(GNode*);
gchar*				getUserName(GNode*);
gboolean			isBlockDevice(GNode *);
gboolean			isCharacterDevice(GNode *);
gboolean			isDirectory(GNode *);
gboolean			isDirectoryFilled(GNode *);
gboolean			isDirectoryEmpty(GNode *);
gboolean			isDirectoryInaccessible(GNode *);
gboolean			isFifo(GNode *);
gboolean			isLink(GNode *);
gboolean			isRegularFile(GNode *);
gboolean			isSocket(GNode *);

#endif /* __FILE_UTILS_H__ */

