/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#ifndef __FMWINDOW_SIGNALS_H__
#define __FMWINDOW_SIGNALS_H__

#define COLLAPSE_EXPAND_TIME	500
#define PAN_TIME            	20
    
struct BrowserState
{
	GList		*pExpandedDirs;
	gchar		*pFocusedFile;
	gchar		*pZoomDirectory;
};

void				fmWindow_acceleratorAdd(GtkWidget*, guint, GtkAccelGroup*, guint, GdkModifierType, GtkAccelFlags, gpointer);
void				fmWindow_acceleratorRemove(GtkWidget*, guint, GtkAccelGroup*, guint, GdkModifierType, gpointer);
gboolean			fmWindow_buttonBookmarkButtonPress(GtkWidget*, GdkEventButton*, gpointer);
void				fmWindow_buttonBookmarkClicked(GtkButton*, gpointer);
gboolean			fmWindow_buttonBookmarkEnterNotify(GtkWidget*, GdkEventCrossing*, gpointer);
gboolean			fmWindow_buttonBookmarkLeaveNotify(GtkWidget*, GdkEventCrossing*, gpointer);
void				fmWindow_buttonBookmarkClear(GtkMenuItem*, gpointer);
void				fmWindow_buttonBookmarkGoTo(GtkMenuItem*, gpointer);
void				fmWindow_buttonBookmarkSet(GtkMenuItem*, gpointer);
void				fmWindow_buttonHideDotFilesToggled(GtkToggleButton*, gpointer);
gboolean			fmWindow_comboKeyPress(GtkWidget*, GdkEventKey*, gpointer);
void				fmWindow_comboPopupMenuItemSelect(GtkMenuItem*, gpointer);
void				fmWindow_comboPositionPopupMenu(GtkMenu*, gint*, gint*, gpointer);
void				fmWindow_comboTextEntryActivate(GtkEditable*, gpointer);
void				fmWindow_comboTextEntryDragDataReceived(GtkWidget*, GdkDragContext*, gint, gint, GtkSelectionData*, guint, guint, gpointer);
void				fmWindow_comboTextEntryDragDrop(GtkWidget*, GdkDragContext*, gint, gint, guint, gpointer);
void				fmWindow_comboTextEntryDragMotion(GtkWidget*, GdkDragContext*, gint, gint, guint, gpointer);
gboolean			fmWindow_ctreeButtonPress(GtkWidget*, GdkEventButton*, gpointer);
gboolean			fmWindow_ctreeButtonRelease(GtkWidget*, GdkEventButton*, gpointer);
void				fmWindow_ctreeClickColumn(GtkCList*, gint, gpointer);
void				fmWindow_ctreeCollapse(GtkCTree*, GtkCTreeNode*, gpointer);
void				fmWindow_ctreeDragBegin(GtkWidget*, GdkDragContext*, gpointer);
void				fmWindow_ctreeDragDataGet(GtkWidget*, GdkDragContext*, GtkSelectionData*, guint, guint, gpointer);
void				fmWindow_ctreeDragDataReceived(GtkWidget*, GdkDragContext*, gint, gint, GtkSelectionData*, guint, guint, gpointer);
void				fmWindow_ctreeDragDrop(GtkWidget*, GdkDragContext*, gint, gint, guint, gpointer);
void				fmWindow_ctreeDragEnd(GtkWidget*, GdkDragContext*, gpointer);
void				fmWindow_ctreeDragLeave(GtkWidget*, GdkDragContext*, guint, gpointer);
void				fmWindow_ctreeDragMotion(GtkWidget*, GdkDragContext*, gint, gint, guint, gpointer);
gint				fmWindow_ctreeDragMotionTimeout(gpointer);
void				fmWindow_ctreeExpand(GtkCTree*, GtkCTreeNode*, gpointer);
void				fmWindow_ctreeHAdjustmentChanged(GtkAdjustment*, gpointer);
gboolean			fmWindow_ctreeKeyPress(GtkWidget*, GdkEventKey*, gpointer);
void				fmWindow_ctreeMenuItemAbout(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemBrowserClose(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemBrowserCollapseEverything(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemBrowserCopyState(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemBrowserNew(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemBrowserPasteState(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemBrowserRefresh(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemBrowserUnZoom(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemDirectoryOpenInNewWindow(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemDirectoryRefresh(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemDirectoryZoom(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemPreferences(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemSelectionClear(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemSelectionCopyFocusToComboEntry(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemSelectionCopyToXClipboard(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemSelectionDeselectDirectory(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemSelectionSelectDirectory(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemColumnsToggleColumn(GtkMenuItem*, gpointer);
void				fmWindow_ctreeMenuItemQuit(GtkMenuItem*, gpointer);
gboolean			fmWindow_ctreeMotionNotify(GtkWidget*, GdkEventMotion*, gpointer);
void				fmWindow_ctreeSelectionClear(GtkWidget*, GdkEventSelection*, gpointer);
void				fmWindow_ctreeSelectionGet(GtkWidget*, GtkSelectionData*, guint, guint, gpointer);
void				fmWindow_ctreeSizeAllocate(GtkWidget*, GtkAllocation*, gpointer);
gboolean			fmWindow_destroyButtonBookmark(GtkWidget*, gpointer);
gboolean			fmWindow_destroyMenuItem(GtkWidget*, gpointer);
gboolean			fmWindow_deleteWindow(GtkWidget*, GdkEvent*, gpointer);
gboolean			fmWindow_destroyWindow(GtkWidget*, gpointer);
gboolean			fmWindow_grabbedWidgetButtonRelease(GtkWidget*, GdkEventButton*, gpointer);
gboolean			fmWindow_grabbedWidgetKeyPress(GtkWidget*, GdkEventKey*, gpointer);
gboolean			fmWindow_panButtonPress(GtkWidget*, GdkEventButton*, gpointer);
gboolean			fmWindow_panButtonRelease(GtkWidget*, GdkEventButton*, gpointer);
gboolean			fmWindow_panMotionNotify(GtkWidget*, GdkEventMotion*, gpointer);

#endif /* __FMWINDOW_SIGNALS_H__ */

