/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#ifndef __LAYOUT_H__
#define __LAYOUT_H__

#include "fmwindow.h"
#include "preferences.h"

struct LayoutEntry
{
	struct FmWindow	*fmWindow;
	guint			name;

	union
	{
		struct
		{
			guint		x;
			guint		y;
			guint		width;
			guint		height;
		} geometry;
		
		struct
		{
			gchar		*focus;
			gboolean	hideDotFiles;
			gboolean	sortType;
			gboolean	sortDirection;
			gchar		*zoom;
		} appearance;

		struct
		{
			guint		id;
			gchar		*path;
		} bookmark;

		struct
		{
			guint		id;
		} column;

		struct
		{
			gchar		*path;
		} expandeddir;

		struct
		{
			gchar		*path;
		} comboEntry;
	} values;
};

void				layout_clear();
void				layout_load();
void				layout_save(struct Preferences *preferences);

#endif /* __LAYOUT_H__ */

