/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#include "accelkey.h"
#include "ctreecolumn.h"
#include "filetype.h"
#include "fmdialog.h"
#include "fmwindow.h"
#include "preferences.h"
#include "preferenceswindow.h"
#include "preferenceswindow_signals.h"
#include "rowstyle.h"

extern struct Preferences	*pgPreferences;
extern gchar				*pgColumnTitles[];

void preferencesWindow_destroy(struct PreferencesWindow **preferencesWindow)
{
	if(*preferencesWindow)
	{
		gtk_widget_destroy((*preferencesWindow)->pLabelNotYetImplemented2);
		gtk_widget_destroy((*preferencesWindow)->pLabelNotYetImplemented1);
		gtk_widget_destroy((*preferencesWindow)->pButtonClearLayoutNow);
		gtk_widget_destroy((*preferencesWindow)->pButtonSaveLayoutNow);
		gtk_widget_destroy((*preferencesWindow)->pHBoxLayout);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonLayoutSaveBookmarks);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonLayoutSaveComboHistory);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonLayoutSaveExpandedDirs);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonLayoutSaveGeometry);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonLayoutSaveBrowserAppearance);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonLayoutSaveOnExit);
		gtk_widget_destroy((*preferencesWindow)->pVBoxLayout);
		gtk_widget_destroy((*preferencesWindow)->pFrameLayout);
		gtk_widget_destroy((*preferencesWindow)->pButtonClearPreferencesNow);
		gtk_widget_destroy((*preferencesWindow)->pButtonSavePreferencesNow);
		gtk_widget_destroy((*preferencesWindow)->pHBoxPreferences);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonPreferencesSaveOnExit);
		gtk_widget_destroy((*preferencesWindow)->pVBoxPreferences);
		gtk_widget_destroy((*preferencesWindow)->pFramePreferences);
		gtk_widget_destroy((*preferencesWindow)->pEntryHeight);
		gtk_widget_destroy((*preferencesWindow)->pLabelHeight);
		gtk_widget_destroy((*preferencesWindow)->pEntryWidth);
		gtk_widget_destroy((*preferencesWindow)->pLabelWidth);
		gtk_widget_destroy((*preferencesWindow)->pEntryY);
		gtk_widget_destroy((*preferencesWindow)->pLabelY);
		gtk_widget_destroy((*preferencesWindow)->pEntryX);
		gtk_widget_destroy((*preferencesWindow)->pLabelX);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonDefaultPosition);
		gtk_widget_destroy((*preferencesWindow)->pTableDefaultPositionSize);
		gtk_widget_destroy((*preferencesWindow)->pFrameDefaultPositionSize);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonSortIgnoreCase);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonSortDirectoriesFirst);
		gtk_widget_destroy((*preferencesWindow)->pVBoxSort);
		gtk_widget_destroy((*preferencesWindow)->pFrameSort);
		gtk_widget_destroy((*preferencesWindow)->pCListColumns);
		gtk_widget_destroy((*preferencesWindow)->pVBoxColumnOrder);
		gtk_widget_destroy((*preferencesWindow)->pFrameColumnOrder);
		gtk_widget_destroy((*preferencesWindow)->pEntryComboPopdownLength);
		gtk_widget_destroy((*preferencesWindow)->pLabelComboPopdownLength);
		gtk_widget_destroy((*preferencesWindow)->pTableComboBox);
		gtk_widget_destroy((*preferencesWindow)->pFrameComboBox);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonCharacterBrowsingIgnoreCase);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonCharacterBrowsingEnableSpacebar);
		gtk_widget_destroy((*preferencesWindow)->pCheckButtonCharacterBrowsingEnabled);
		gtk_widget_destroy((*preferencesWindow)->pVBoxCharacterBrowsing);
		gtk_widget_destroy((*preferencesWindow)->pFrameCharacterBrowsing);
		gtk_widget_destroy((*preferencesWindow)->pNotebookMain);
		gtk_widget_destroy((*preferencesWindow)->pHBoxMain);
/*		gtk_widget_destroy((*preferencesWindow)->pCTreeCategories);
		gtk_widget_destroy((*preferencesWindow)->pFrameNotebook);*/
		gtk_widget_destroy((*preferencesWindow)->pDialog);

        if((*preferencesWindow)->pPreferences)
		{
			preferences_destroy((*preferencesWindow)->pPreferences);
		}
        
		g_free(*preferencesWindow);

		*preferencesWindow = NULL;
	}
}

struct PreferencesWindow* preferencesWindow_new()
{
	static struct PreferencesWindow	*preferences_window = NULL;
	guint							page_index = 0;
	gint							counter = 0;
	GtkCTreeNode					*ctree_node = NULL;
	gchar							temp_string[255];
  
	if(preferences_window)
	{
		gdk_window_raise(preferences_window->pDialog->window);
	}
	else
	{
		preferences_window = g_new(struct PreferencesWindow, 1);
		if(preferences_window)
		{
			preferences_window->pButtonClearPreferencesNow = NULL;
			preferences_window->pButtonClearLayoutNow = NULL;
			preferences_window->pButtonSaveLayoutNow = NULL;
			preferences_window->pButtonSavePreferencesNow = NULL;
			preferences_window->pCheckButtonCharacterBrowsingEnabled = NULL;
			preferences_window->pCheckButtonCharacterBrowsingEnableSpacebar = NULL;
			preferences_window->pCheckButtonCharacterBrowsingIgnoreCase = NULL;
			preferences_window->pCheckButtonDefaultPosition = NULL;
			preferences_window->pCheckButtonLayoutSaveBookmarks = NULL;
			preferences_window->pCheckButtonLayoutSaveComboHistory = NULL;
			preferences_window->pCheckButtonLayoutSaveExpandedDirs = NULL;
			preferences_window->pCheckButtonLayoutSaveGeometry = NULL;
			preferences_window->pCheckButtonLayoutSaveBrowserAppearance = NULL;
			preferences_window->pCheckButtonLayoutSaveOnExit = NULL;
			preferences_window->pCheckButtonPreferencesSaveOnExit = NULL;
			preferences_window->pCheckButtonSortDirectoriesFirst = NULL;
			preferences_window->pCheckButtonSortIgnoreCase = NULL;
			preferences_window->pCListColumns = NULL;
			preferences_window->pCTreeCategories = NULL;
			preferences_window->pDialog = NULL;
			preferences_window->pEntryComboPopdownLength = NULL;
			preferences_window->pEntryX = NULL;
			preferences_window->pEntryY = NULL;
			preferences_window->pEntryWidth = NULL;
			preferences_window->pEntryHeight = NULL;
			preferences_window->pFrameDefaultPositionSize = NULL;
			preferences_window->pFrameCharacterBrowsing = NULL;
			preferences_window->pFrameColumnOrder = NULL;
			preferences_window->pFrameComboBox = NULL;
			preferences_window->pFramePreferences = NULL;
			preferences_window->pFrameLayout = NULL;
			preferences_window->pFrameNotebook = NULL;
			preferences_window->pFrameSort = NULL;
			preferences_window->pLabelComboPopdownLength = NULL;
			preferences_window->pLabelNotYetImplemented1 = NULL;
			preferences_window->pLabelNotYetImplemented2 = NULL;
			preferences_window->pLabelX = NULL;
			preferences_window->pLabelY = NULL;
			preferences_window->pLabelWidth = NULL;
			preferences_window->pLabelHeight = NULL;
			preferences_window->pNotebookMain = NULL;
			preferences_window->pHBoxMain = NULL;
			preferences_window->pHBoxLayout = NULL;
			preferences_window->pHBoxPreferences = NULL;
			preferences_window->pTableComboBox = NULL;
			preferences_window->pTableDefaultPositionSize = NULL;
			preferences_window->pVBoxCharacterBrowsing = NULL;
			preferences_window->pVBoxColumnOrder = NULL;
			preferences_window->pVBoxLayout = NULL;
			preferences_window->pVBoxPageAppearance = NULL;
			preferences_window->pVBoxPageNavigation = NULL;
			preferences_window->pVBoxPageSession = NULL;
			preferences_window->pVBoxPageRowStyles = NULL;
			preferences_window->pVBoxPageFileTypes = NULL;
			preferences_window->pVBoxPreferences = NULL;
			preferences_window->pVBoxSort = NULL;

			preferences_window->pPreferences = preferences_duplicate(pgPreferences);

			if(preferences_window->pPreferences)
			{
				preferences_window->pDialog = fmDialog_new("Preferences", "fm_preferences", GTK_WIN_POS_NONE, FALSE, TRUE, FALSE,
					 "OK", preferencesWindow_buttonOk, &preferences_window, FALSE, FALSE,
					 "Save", preferencesWindow_buttonSave, &preferences_window, FALSE, FALSE,
					 "Cancel", preferencesWindow_buttonCancel, &preferences_window, TRUE, TRUE,
					 NULL);

				/* The main hbox */
				preferences_window->pHBoxMain = gtk_hbox_new(FALSE, 6);
				gtk_container_set_border_width(GTK_CONTAINER (preferences_window->pHBoxMain), 6);
				gtk_box_pack_start(GTK_BOX(GTK_DIALOG(preferences_window->pDialog)->vbox), preferences_window->pHBoxMain, TRUE, TRUE, 0);

				/* The categories tree */
				preferences_window->pCTreeCategories = gtk_ctree_new(1, 0);
				gtk_clist_column_titles_show(GTK_CLIST(preferences_window->pCTreeCategories));
				gtk_clist_set_column_title(GTK_CLIST(preferences_window->pCTreeCategories), 0, "Categories");
				gtk_ctree_set_indent(GTK_CTREE(preferences_window->pCTreeCategories), 15);
				gtk_clist_column_titles_passive(GTK_CLIST(preferences_window->pCTreeCategories));
				gtk_widget_set_usize(preferences_window->pCTreeCategories, 140, 0);
				gtk_clist_set_selection_mode(GTK_CLIST(preferences_window->pCTreeCategories), GTK_SELECTION_SINGLE);
				gtk_box_pack_start(GTK_BOX(preferences_window->pHBoxMain), preferences_window->pCTreeCategories, FALSE, FALSE, 0);

				/* The main preferences notebook */
				preferences_window->pFrameNotebook = gtk_frame_new(NULL);
				gtk_frame_set_shadow_type(GTK_FRAME(preferences_window->pFrameNotebook), GTK_SHADOW_IN);
				gtk_box_pack_start(GTK_BOX(preferences_window->pHBoxMain), preferences_window->pFrameNotebook, TRUE, TRUE, 0);

				preferences_window->pNotebookMain = gtk_notebook_new();
				gtk_notebook_set_show_tabs(GTK_NOTEBOOK(preferences_window->pNotebookMain), FALSE);
				gtk_notebook_set_show_border(GTK_NOTEBOOK(preferences_window->pNotebookMain), FALSE);
				gtk_container_add(GTK_CONTAINER(preferences_window->pFrameNotebook), preferences_window->pNotebookMain);

				gtk_object_set_user_data(GTK_OBJECT(preferences_window->pCTreeCategories), preferences_window->pNotebookMain);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCTreeCategories), "tree_select_row", (GtkSignalFunc)preferencesWindow_ctreeSelect, NULL);

				page_index = 0;

				/* Navigation page */
				preferences_window->pVBoxPageNavigation = preferencesWindow_notebookAppendPage(GTK_NOTEBOOK(preferences_window->pNotebookMain),
					"Navigation Settings",
					GTK_CTREE(preferences_window->pCTreeCategories),
					"Navigation",
					NULL,
					&ctree_node,
					page_index);
				page_index++;

				gtk_ctree_select(GTK_CTREE(preferences_window->pCTreeCategories), ctree_node);

				preferences_window->pFrameCharacterBrowsing = gtk_frame_new("Character Browsing"); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageNavigation), preferences_window->pFrameCharacterBrowsing, FALSE, FALSE, 0);

				preferences_window->pVBoxCharacterBrowsing = gtk_vbox_new(FALSE, 2);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pVBoxCharacterBrowsing), 2);
				gtk_container_add (GTK_CONTAINER(preferences_window->pFrameCharacterBrowsing), preferences_window->pVBoxCharacterBrowsing);

				preferences_window->pCheckButtonCharacterBrowsingEnabled = gtk_check_button_new_with_label("Enabled");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonCharacterBrowsingEnabled), preferences_window->pPreferences->characterBrowsingEnabled);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxCharacterBrowsing), preferences_window->pCheckButtonCharacterBrowsingEnabled, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonCharacterBrowsingEnabled), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->characterBrowsingEnabled);

				preferences_window->pCheckButtonCharacterBrowsingEnableSpacebar = gtk_check_button_new_with_label("Enable spacebar (use ctrl+space for selections)");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonCharacterBrowsingEnableSpacebar), preferences_window->pPreferences->characterBrowsingEnableSpacebar);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxCharacterBrowsing), preferences_window->pCheckButtonCharacterBrowsingEnableSpacebar, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonCharacterBrowsingEnableSpacebar), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->characterBrowsingEnableSpacebar);

				preferences_window->pCheckButtonCharacterBrowsingIgnoreCase = gtk_check_button_new_with_label("Ignore case");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonCharacterBrowsingIgnoreCase), preferences_window->pPreferences->characterBrowsingIgnoreCase);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxCharacterBrowsing), preferences_window->pCheckButtonCharacterBrowsingIgnoreCase, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonCharacterBrowsingIgnoreCase), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->characterBrowsingIgnoreCase);

				preferences_window->pFrameComboBox = gtk_frame_new("Combo Box"); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageNavigation), preferences_window->pFrameComboBox, FALSE, FALSE, 0);

				preferences_window->pTableComboBox = gtk_table_new(1, 2, FALSE);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pTableComboBox), 2);
				gtk_container_add(GTK_CONTAINER(preferences_window->pFrameComboBox), preferences_window->pTableComboBox);

				preferences_window->pLabelComboPopdownLength = gtk_label_new("Popdown Length");
				gtk_table_attach(GTK_TABLE(preferences_window->pTableComboBox), preferences_window->pLabelComboPopdownLength, 0, 1, 0, 1, GTK_FILL, GTK_FILL, 5, 0);

				sprintf(temp_string, "%d", preferences_window->pPreferences->comboPopdownLength);
				preferences_window->pEntryComboPopdownLength = gtk_entry_new_with_max_length(4);
				gtk_entry_set_text(GTK_ENTRY(preferences_window->pEntryComboPopdownLength), temp_string);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pEntryComboPopdownLength), "changed", GTK_SIGNAL_FUNC(preferencesWindow_entryUnsignedIntegerChange), &preferences_window->pPreferences->comboPopdownLength);
				gtk_table_attach(GTK_TABLE(preferences_window->pTableComboBox), preferences_window->pEntryComboPopdownLength, 1, 2, 0, 1, GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);
				
				/* Appearance page */
				preferences_window->pVBoxPageAppearance = preferencesWindow_notebookAppendPage(GTK_NOTEBOOK(preferences_window->pNotebookMain),
					"Appearance Settings",
					GTK_CTREE(preferences_window->pCTreeCategories),
					"Appearance",
					NULL,
					&ctree_node,
					page_index);
				page_index++;

				preferences_window->pFrameColumnOrder = gtk_frame_new("Order of the columns"); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageAppearance), preferences_window->pFrameColumnOrder, FALSE, FALSE, 0);

				preferences_window->pVBoxColumnOrder = gtk_vbox_new(FALSE, 2);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pVBoxColumnOrder), 2);
				gtk_container_add (GTK_CONTAINER(preferences_window->pFrameColumnOrder), preferences_window->pVBoxColumnOrder);

				preferences_window->pCListColumns = gtk_clist_new(1);
				gtk_clist_column_titles_hide(GTK_CLIST(preferences_window->pCListColumns));
				gtk_clist_set_selection_mode(GTK_CLIST(preferences_window->pCListColumns), GTK_SELECTION_BROWSE);
				gtk_clist_set_reorderable(GTK_CLIST(preferences_window->pCListColumns), TRUE);
				for(counter = COLUMN_SIZE; counter <= COLUMN_CHANGE_TIME; counter++)
				{
					gtk_clist_append(GTK_CLIST(preferences_window->pCListColumns), &pgColumnTitles[((struct CtreeColumn *)g_list_nth_data(preferences_window->pPreferences->pCtreeColumns, counter))->type]);
				}
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxColumnOrder), preferences_window->pCListColumns, TRUE, TRUE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCListColumns), "row_move", (GtkSignalFunc)preferencesWindow_clistColumnsRowMove, preferences_window);

				preferences_window->pFrameSort = gtk_frame_new("Sort"); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageAppearance), preferences_window->pFrameSort, FALSE, FALSE, 0);

				preferences_window->pVBoxSort = gtk_vbox_new(FALSE, 2);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pVBoxSort), 2);
				gtk_container_add (GTK_CONTAINER(preferences_window->pFrameSort), preferences_window->pVBoxSort);

				preferences_window->pCheckButtonSortDirectoriesFirst = gtk_check_button_new_with_label("Directories first");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonSortDirectoriesFirst), preferences_window->pPreferences->sortDirectoriesFirst);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxSort), preferences_window->pCheckButtonSortDirectoriesFirst, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonSortDirectoriesFirst), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sortDirectoriesFirst);

				preferences_window->pCheckButtonSortIgnoreCase = gtk_check_button_new_with_label("Ignore case");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonSortIgnoreCase), preferences_window->pPreferences->sortIgnoreCase);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxSort), preferences_window->pCheckButtonSortIgnoreCase, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonSortIgnoreCase), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sortIgnoreCase);

				preferences_window->pFrameDefaultPositionSize = gtk_frame_new("Default window position & size"); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageAppearance), preferences_window->pFrameDefaultPositionSize, FALSE, FALSE, 0);

				preferences_window->pTableDefaultPositionSize = gtk_table_new(5, 2, FALSE);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pTableDefaultPositionSize), 2);
				gtk_container_add(GTK_CONTAINER(preferences_window->pFrameDefaultPositionSize), preferences_window->pTableDefaultPositionSize);

				preferences_window->pCheckButtonDefaultPosition = gtk_check_button_new_with_label("Use default position");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonDefaultPosition), preferences_window->pPreferences->fmWindowDefaultPosition);
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pCheckButtonDefaultPosition, 0, 2, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonDefaultPosition), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggledDefaultPosition, preferences_window);

				preferences_window->pLabelX = gtk_label_new("X");
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pLabelX, 0, 1, 1, 2, GTK_FILL, GTK_FILL, 5, 0);

				sprintf(temp_string, "%d", preferences_window->pPreferences->fmWindowX);
				preferences_window->pEntryX = gtk_entry_new_with_max_length(4);
				gtk_entry_set_text(GTK_ENTRY(preferences_window->pEntryX), temp_string);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pEntryX), "changed", GTK_SIGNAL_FUNC(preferencesWindow_entryUnsignedIntegerChange), &preferences_window->pPreferences->fmWindowX);
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pEntryX, 1, 2, 1, 2, GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);
				
				preferences_window->pLabelY = gtk_label_new("Y");
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pLabelY, 0, 1, 2, 3, GTK_FILL, GTK_FILL, 5, 0);

				sprintf(temp_string, "%d", preferences_window->pPreferences->fmWindowY);
				preferences_window->pEntryY = gtk_entry_new_with_max_length(4);
				gtk_entry_set_text(GTK_ENTRY(preferences_window->pEntryY), temp_string);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pEntryY), "changed", GTK_SIGNAL_FUNC(preferencesWindow_entryUnsignedIntegerChange), &preferences_window->pPreferences->fmWindowY);
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pEntryY, 1, 2, 2, 3, GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);
				
				if(!preferences_window->pPreferences->fmWindowDefaultPosition)
				{
					gtk_widget_set_sensitive(preferences_window->pEntryX, FALSE);
					gtk_widget_set_sensitive(preferences_window->pEntryY, FALSE);
				}
				
				preferences_window->pLabelWidth = gtk_label_new("Width");
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pLabelWidth, 0, 1, 3, 4, GTK_FILL, GTK_FILL, 5, 0);

				sprintf(temp_string, "%d", preferences_window->pPreferences->fmWindowWidth);
				preferences_window->pEntryWidth = gtk_entry_new_with_max_length(4);
				gtk_entry_set_text(GTK_ENTRY(preferences_window->pEntryWidth), temp_string);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pEntryWidth), "changed", GTK_SIGNAL_FUNC(preferencesWindow_entryUnsignedIntegerChange), &preferences_window->pPreferences->fmWindowWidth);
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pEntryWidth, 1, 2, 3, 4, GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);
				
				preferences_window->pLabelHeight = gtk_label_new("Height");
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pLabelHeight, 0, 1, 4, 5, GTK_FILL, GTK_FILL, 5, 0);

				sprintf(temp_string, "%d", preferences_window->pPreferences->fmWindowHeight);
				preferences_window->pEntryHeight = gtk_entry_new_with_max_length(4);
				gtk_entry_set_text(GTK_ENTRY(preferences_window->pEntryHeight), temp_string);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pEntryHeight), "changed", GTK_SIGNAL_FUNC(preferencesWindow_entryUnsignedIntegerChange), &preferences_window->pPreferences->fmWindowHeight);
				gtk_table_attach(GTK_TABLE(preferences_window->pTableDefaultPositionSize), preferences_window->pEntryHeight, 1, 2, 4, 5, GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);
				
				/* Session page */
				preferences_window->pVBoxPageSession = preferencesWindow_notebookAppendPage(GTK_NOTEBOOK(preferences_window->pNotebookMain),
					"Session Settings",
					GTK_CTREE(preferences_window->pCTreeCategories),
					"Session",
					NULL,
					&ctree_node,
					page_index);
				page_index++;

				preferences_window->pFramePreferences = gtk_frame_new("Preferences"); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageSession), preferences_window->pFramePreferences, FALSE, FALSE, 0);

				preferences_window->pVBoxPreferences = gtk_vbox_new(FALSE, 2);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pVBoxPreferences), 2);
				gtk_container_add (GTK_CONTAINER(preferences_window->pFramePreferences), preferences_window->pVBoxPreferences);

				preferences_window->pCheckButtonPreferencesSaveOnExit = gtk_check_button_new_with_label("Save on exit");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonPreferencesSaveOnExit), preferences_window->pPreferences->sessionSavePreferencesOnExit);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPreferences), preferences_window->pCheckButtonPreferencesSaveOnExit, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonPreferencesSaveOnExit), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sessionSavePreferencesOnExit);

				preferences_window->pHBoxPreferences = gtk_hbox_new (FALSE, 2);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pHBoxPreferences), 4);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPreferences), preferences_window->pHBoxPreferences, FALSE, FALSE, 0);

				preferences_window->pButtonSavePreferencesNow = gtk_button_new_with_label("Save now");
				gtk_box_pack_start(GTK_BOX(preferences_window->pHBoxPreferences), preferences_window->pButtonSavePreferencesNow, TRUE, TRUE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pButtonSavePreferencesNow), "clicked", (GtkSignalFunc)preferencesWindow_buttonSavePreferencesNow, preferences_window->pPreferences);

				preferences_window->pButtonClearPreferencesNow = gtk_button_new_with_label("Clear now");
				gtk_box_pack_start(GTK_BOX(preferences_window->pHBoxPreferences), preferences_window->pButtonClearPreferencesNow, TRUE, TRUE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pButtonClearPreferencesNow), "clicked", (GtkSignalFunc)preferencesWindow_buttonClearPreferencesNow, NULL);

				preferences_window->pFrameLayout = gtk_frame_new("Layout"); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageSession), preferences_window->pFrameLayout, FALSE, FALSE, 0);

				preferences_window->pVBoxLayout = gtk_vbox_new(FALSE, 2);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pVBoxLayout), 2);
				gtk_container_add (GTK_CONTAINER(preferences_window->pFrameLayout), preferences_window->pVBoxLayout);

				preferences_window->pCheckButtonLayoutSaveOnExit = gtk_check_button_new_with_label("Save on exit");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonLayoutSaveOnExit), preferences_window->pPreferences->sessionSaveLayoutOnExit);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxLayout), preferences_window->pCheckButtonLayoutSaveOnExit, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonLayoutSaveOnExit), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggledSaveLayout, preferences_window);

				preferences_window->pCheckButtonLayoutSaveBookmarks = gtk_check_button_new_with_label("Save bookmarks");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonLayoutSaveBookmarks), preferences_window->pPreferences->sessionSaveLayoutBookmarks);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxLayout), preferences_window->pCheckButtonLayoutSaveBookmarks, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonLayoutSaveBookmarks), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sessionSaveLayoutBookmarks);

				preferences_window->pCheckButtonLayoutSaveBrowserAppearance = gtk_check_button_new_with_label("Save browser appearance");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonLayoutSaveBrowserAppearance), preferences_window->pPreferences->sessionSaveLayoutBrowserAppearance);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxLayout), preferences_window->pCheckButtonLayoutSaveBrowserAppearance, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonLayoutSaveBrowserAppearance), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sessionSaveLayoutBrowserAppearance);

				preferences_window->pCheckButtonLayoutSaveComboHistory = gtk_check_button_new_with_label("Save combobox history");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonLayoutSaveComboHistory), preferences_window->pPreferences->sessionSaveLayoutComboHistory);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxLayout), preferences_window->pCheckButtonLayoutSaveComboHistory, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonLayoutSaveComboHistory), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sessionSaveLayoutComboHistory);

				preferences_window->pCheckButtonLayoutSaveExpandedDirs = gtk_check_button_new_with_label("Save expanded directories");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonLayoutSaveExpandedDirs), preferences_window->pPreferences->sessionSaveLayoutExpandedDirs);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxLayout), preferences_window->pCheckButtonLayoutSaveExpandedDirs, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonLayoutSaveExpandedDirs), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sessionSaveLayoutExpandedDirs);

				preferences_window->pCheckButtonLayoutSaveGeometry = gtk_check_button_new_with_label("Save window dimension & position");
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(preferences_window->pCheckButtonLayoutSaveGeometry), preferences_window->pPreferences->sessionSaveLayoutGeometry);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxLayout), preferences_window->pCheckButtonLayoutSaveGeometry, FALSE, FALSE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pCheckButtonLayoutSaveGeometry), "toggled", (GtkSignalFunc)preferencesWindow_buttonToggled, &preferences_window->pPreferences->sessionSaveLayoutGeometry);

				if(!preferences_window->pPreferences->sessionSaveLayoutOnExit)
				{
					gtk_widget_set_sensitive(preferences_window->pCheckButtonLayoutSaveBookmarks, FALSE);
					gtk_widget_set_sensitive(preferences_window->pCheckButtonLayoutSaveExpandedDirs, FALSE);
					gtk_widget_set_sensitive(preferences_window->pCheckButtonLayoutSaveGeometry, FALSE);
					gtk_widget_set_sensitive(preferences_window->pCheckButtonLayoutSaveComboHistory, FALSE);
					gtk_widget_set_sensitive(preferences_window->pCheckButtonLayoutSaveBrowserAppearance, FALSE);
				}
				
				preferences_window->pHBoxLayout = gtk_hbox_new (FALSE, 2);
				gtk_container_set_border_width(GTK_CONTAINER(preferences_window->pHBoxLayout), 4);
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxLayout), preferences_window->pHBoxLayout, FALSE, FALSE, 0);

				preferences_window->pButtonSaveLayoutNow = gtk_button_new_with_label("Save now");
				gtk_box_pack_start(GTK_BOX(preferences_window->pHBoxLayout), preferences_window->pButtonSaveLayoutNow, TRUE, TRUE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pButtonSaveLayoutNow), "clicked", (GtkSignalFunc)preferencesWindow_buttonSaveLayoutNow, preferences_window->pPreferences);

				preferences_window->pButtonClearLayoutNow = gtk_button_new_with_label("Clear now");
				gtk_box_pack_start(GTK_BOX(preferences_window->pHBoxLayout), preferences_window->pButtonClearLayoutNow, TRUE, TRUE, 0);
				gtk_signal_connect(GTK_OBJECT(preferences_window->pButtonClearLayoutNow), "clicked", (GtkSignalFunc)preferencesWindow_buttonClearLayoutNow, NULL);

				/* Row Style page */
				preferences_window->pVBoxPageRowStyles = preferencesWindow_notebookAppendPage(GTK_NOTEBOOK(preferences_window->pNotebookMain),
					"Row Styles Settings",
					GTK_CTREE(preferences_window->pCTreeCategories),
					"Row Styles",
					NULL,
					&ctree_node,
					page_index);
				page_index++;

				preferences_window->pLabelNotYetImplemented1 = gtk_label_new("Not yet implemented."); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageRowStyles), preferences_window->pLabelNotYetImplemented1, FALSE, FALSE, 0);

				/* File Types page */
				preferences_window->pVBoxPageFileTypes = preferencesWindow_notebookAppendPage(GTK_NOTEBOOK(preferences_window->pNotebookMain),
					"File Types Settings",
					GTK_CTREE(preferences_window->pCTreeCategories),
					"File Types",
					NULL,
					&ctree_node,
					page_index);
				page_index++;

				preferences_window->pLabelNotYetImplemented2 = gtk_label_new("Not yet implemented."); 
				gtk_box_pack_start(GTK_BOX(preferences_window->pVBoxPageFileTypes), preferences_window->pLabelNotYetImplemented2, FALSE, FALSE, 0);

				gtk_widget_show(preferences_window->pLabelNotYetImplemented2);
				gtk_widget_show(preferences_window->pLabelNotYetImplemented1);
				gtk_widget_show(preferences_window->pButtonClearLayoutNow);
				gtk_widget_show(preferences_window->pButtonSaveLayoutNow);
				gtk_widget_show(preferences_window->pHBoxLayout);
				gtk_widget_show(preferences_window->pCheckButtonLayoutSaveBookmarks);
				gtk_widget_show(preferences_window->pCheckButtonLayoutSaveComboHistory);
				gtk_widget_show(preferences_window->pCheckButtonLayoutSaveExpandedDirs);
				gtk_widget_show(preferences_window->pCheckButtonLayoutSaveGeometry);
				gtk_widget_show(preferences_window->pCheckButtonLayoutSaveBrowserAppearance);
				gtk_widget_show(preferences_window->pCheckButtonLayoutSaveOnExit);
				gtk_widget_show(preferences_window->pVBoxLayout);
				gtk_widget_show(preferences_window->pFrameLayout);
				gtk_widget_show(preferences_window->pButtonClearPreferencesNow);
				gtk_widget_show(preferences_window->pButtonSavePreferencesNow);
				gtk_widget_show(preferences_window->pHBoxPreferences);
				gtk_widget_show(preferences_window->pCheckButtonPreferencesSaveOnExit);
				gtk_widget_show(preferences_window->pVBoxPreferences);
				gtk_widget_show(preferences_window->pFramePreferences);
				gtk_widget_show(preferences_window->pEntryHeight);
				gtk_widget_show(preferences_window->pLabelHeight);
				gtk_widget_show(preferences_window->pEntryWidth);
				gtk_widget_show(preferences_window->pLabelWidth);
				gtk_widget_show(preferences_window->pEntryY);
				gtk_widget_show(preferences_window->pLabelY);
				gtk_widget_show(preferences_window->pEntryX);
				gtk_widget_show(preferences_window->pLabelX);
				gtk_widget_show(preferences_window->pCheckButtonDefaultPosition);
				gtk_widget_show(preferences_window->pTableDefaultPositionSize);
				gtk_widget_show(preferences_window->pFrameDefaultPositionSize);
				gtk_widget_show(preferences_window->pCheckButtonSortIgnoreCase);
				gtk_widget_show(preferences_window->pCheckButtonSortDirectoriesFirst);
				gtk_widget_show(preferences_window->pVBoxSort);
				gtk_widget_show(preferences_window->pFrameSort);
				gtk_widget_show(preferences_window->pCListColumns);
				gtk_widget_show(preferences_window->pVBoxColumnOrder);
				gtk_widget_show(preferences_window->pFrameColumnOrder);
				gtk_widget_show(preferences_window->pEntryComboPopdownLength);
				gtk_widget_show(preferences_window->pLabelComboPopdownLength);
				gtk_widget_show(preferences_window->pTableComboBox);
				gtk_widget_show(preferences_window->pFrameComboBox);
				gtk_widget_show(preferences_window->pCheckButtonCharacterBrowsingIgnoreCase);
				gtk_widget_show(preferences_window->pCheckButtonCharacterBrowsingEnableSpacebar);
				gtk_widget_show(preferences_window->pCheckButtonCharacterBrowsingEnabled);
				gtk_widget_show(preferences_window->pVBoxCharacterBrowsing);
				gtk_widget_show(preferences_window->pFrameCharacterBrowsing);
				gtk_widget_show(preferences_window->pNotebookMain);
				gtk_widget_show(preferences_window->pHBoxMain);
				gtk_widget_show(preferences_window->pCTreeCategories);
				gtk_widget_show(preferences_window->pFrameNotebook);
				gtk_widget_show(preferences_window->pDialog);
			}
		}
	}

	return preferences_window;
}

GtkWidget* preferencesWindow_notebookAppendPage(GtkNotebook *notebook, gchar *notebookLabel, GtkCTree *ctree, gchar *treeLabel, GtkCTreeNode *parent, GtkCTreeNode **newNode, gint pageIndex)
{
	GtkWidget *out_vbox;
	GtkWidget *vbox;
	GtkWidget *frame;
	GtkWidget *label;
	gchar     *titles[1];
	
	out_vbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show (out_vbox);
	
	frame = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_OUT);
	gtk_box_pack_start(GTK_BOX(out_vbox), frame, FALSE, TRUE, 0);
	gtk_widget_show(frame);
	
	label = gtk_label_new(notebookLabel);
	gtk_misc_set_alignment(GTK_MISC (label), 0.0, 0.5);
	gtk_misc_set_padding(GTK_MISC (label), 2, 1);
	gtk_container_add(GTK_CONTAINER (frame), label);
	gtk_widget_show(label);
	
	vbox = gtk_vbox_new(FALSE, 2);
	gtk_container_set_border_width(GTK_CONTAINER (vbox), 4);
	gtk_container_add(GTK_CONTAINER(out_vbox), vbox);
	gtk_widget_show(vbox);
	
	titles[0] = treeLabel;
	*newNode = gtk_ctree_insert_node(ctree, parent, NULL, titles, 0, NULL, NULL, NULL, NULL, FALSE, FALSE);
	gtk_ctree_node_set_row_data(ctree, *newNode, (gpointer)pageIndex);
	gtk_notebook_append_page(notebook, out_vbox, NULL);
	
	return vbox;
}


