/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#ifndef __PREFERENCES_WINDOW_H__
#define __PREFERENCES_WINDOW_H__

#include <glib.h>
#include <gtk/gtk.h>

struct PreferencesWindow
{
	struct Preferences	*pPreferences;
	
	GtkWidget		*pButtonClearPreferencesNow;
	GtkWidget		*pButtonClearLayoutNow;
	GtkWidget		*pButtonSaveLayoutNow;
	GtkWidget		*pButtonSavePreferencesNow;
	GtkWidget		*pCheckButtonCharacterBrowsingEnabled;
	GtkWidget		*pCheckButtonCharacterBrowsingEnableSpacebar;
	GtkWidget		*pCheckButtonCharacterBrowsingIgnoreCase;
	GtkWidget		*pCheckButtonDefaultPosition;
	GtkWidget		*pCheckButtonLayoutSaveBookmarks;
	GtkWidget		*pCheckButtonLayoutSaveBrowserAppearance;
	GtkWidget		*pCheckButtonLayoutSaveComboHistory;
	GtkWidget		*pCheckButtonLayoutSaveExpandedDirs;
	GtkWidget		*pCheckButtonLayoutSaveGeometry;
	GtkWidget		*pCheckButtonLayoutSaveOnExit;
	GtkWidget		*pCheckButtonPreferencesSaveOnExit;
	GtkWidget		*pCheckButtonSortDirectoriesFirst;
	GtkWidget		*pCheckButtonSortIgnoreCase;
	GtkWidget		*pCListColumns;
	GtkWidget		*pCTreeCategories;
	GtkWidget		*pDialog;
	GtkWidget		*pEntryComboPopdownLength;
	GtkWidget		*pEntryX;
	GtkWidget		*pEntryY;
	GtkWidget		*pEntryWidth;
	GtkWidget		*pEntryHeight;
	GtkWidget		*pFrameDefaultPositionSize;
	GtkWidget		*pFrameCharacterBrowsing;
	GtkWidget		*pFrameColumnOrder;
	GtkWidget		*pFrameComboBox;
	GtkWidget		*pFramePreferences;
	GtkWidget		*pFrameLayout;
	GtkWidget		*pFrameNotebook;
	GtkWidget		*pFrameSort;
	GtkWidget		*pLabelComboPopdownLength;
	GtkWidget		*pLabelNotYetImplemented1;
	GtkWidget		*pLabelNotYetImplemented2;
	GtkWidget		*pLabelX;
	GtkWidget		*pLabelY;
	GtkWidget		*pLabelWidth;
	GtkWidget		*pLabelHeight;
	GtkWidget		*pNotebookMain;
	GtkWidget		*pHBoxMain;
	GtkWidget		*pHBoxLayout;
	GtkWidget		*pHBoxPreferences;
	GtkWidget		*pTableComboBox;
	GtkWidget		*pTableDefaultPositionSize;
	GtkWidget		*pVBoxCharacterBrowsing;
	GtkWidget		*pVBoxColumnOrder;
	GtkWidget		*pVBoxLayout;
	GtkWidget		*pVBoxPageAppearance;
	GtkWidget		*pVBoxPageNavigation;
	GtkWidget		*pVBoxPageSession;
	GtkWidget		*pVBoxPageRowStyles;
	GtkWidget		*pVBoxPageFileTypes;
	GtkWidget		*pVBoxPreferences;
	GtkWidget		*pVBoxSort;
};

void						preferencesWindow_destroy(struct PreferencesWindow**);
struct PreferencesWindow*	preferencesWindow_new();
GtkWidget*					preferencesWindow_notebookAppendPage(GtkNotebook*, gchar*, GtkCTree*, gchar*, GtkCTreeNode*, GtkCTreeNode**, gint);

#endif /* __PREFERENCES_WINDOW_H__ */

