/*	
**	
**	Copyright (C) 1999 Geert Bevin
**	gbevin@thunderstorms.org
**	http://thunderstorms.org/fm
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2 of the License, or
**	(at your option) any later version.
**	
**	This program is distributed in the hope that it will be useful,
**	but WITHOUT ANY WARRANTY; without even the implied warranty of
**	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**	GNU General Public License for more details.
**	
**	You should have received a copy of the GNU General Public License
**	along with this program; if not, write to the Free Software
**	
**	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**		
*/

#ifndef __ROW_STYLE_H__
#define __ROW_STYLE_H__

#include <glib.h>
#include <gtk/gtk.h>

struct RowStyle
{
	gboolean	deletable;
	GdkColor	foreground;
	GdkColor	background;
	gchar		*pName;
	gchar		*pFilenameClosed;
	gchar		*pFilenameOpened;
	GdkPixmap	*pPixmapClosed;
	GdkBitmap	*pMaskClosed;
	GdkPixmap	*pPixmapOpened;
	GdkBitmap	*pMaskOpened;
	GList		*pReferencingFileTypes;
};

struct RowStyle*	rowStyleFind(GHashTable*, gchar*);
gchar*				rowStyleFindName(GHashTable*, struct RowStyle*);
GdkColor* 			rowStyleGetBackground(GHashTable*, gchar*);
GdkColor* 			rowStyleGetForeground(GHashTable*, gchar*);
struct RowStyle* 	rowStyleNew(GHashTable*, GList*, gchar*, gushort, gushort, gushort, gushort, gushort, gushort, gchar*, gchar*, gboolean);
void 				rowStyleRemove(GHashTable*, gchar*);
gboolean 			rowStylesForEachRemove(gpointer, gpointer, gpointer);
void 				rowStylesRemoveAll(GHashTable*);

#endif /* __ROW_STYLE_H__ */

